#!/bin/bash

printf "
*****************************
  Setting up a new project.
*****************************\n"

read -p "Please enter a path for your new project: " dir_path

mkdir $dir_path
cp cc_solv.conf $dir_path
cp -r rosetta_setup $dir_path

CCsolveDir=$(pwd)
echo $CCsolveDir | sed -e 's/\//\\\//g'i > tmp
CCsolveDir=`cat tmp`
rm tmp

cd $dir_path
sed -i "s/< path to CCsolve >/$CCsolveDir/g" cc_solv.conf

PWD=$(pwd)
printf "
\nNEXT STEPS:
1. Please copy a fasta file and an mtz file to $PWD.
2. Then enter the relevant information into cc_solv.conf
3. If you don't have models yet, go to rosetta_setup and run setup_rosetta.sh
	-> Run Rosetta
	-> Don't forget to enter the location of the Rosetta models in cc_solv.conf!
4. run: nohup $CCsolveDir/cc_solv.sh > log &
"
exit 0

