#!/bin/bash


##  This script is distributed as part of the
##	CCsolve program.
##

# First we test whether all components are installed
command -v phenix.refine >/dev/null || { echo >&2 "CCsolve requires phenix.refine but it's either not installed or not added to PATH variable.  Aborting."; exit 1 ;}
command -v phenix.autobuild >/dev/null || {  echo >&2 "CCsolve requires phenix.autobuild but it's either not installed or not added to PATH variable.  Aborting."; exit 1;}
command -v phaser >/dev/null || {  echo >&2 "CCsolve requires phaser but it's either not installed or not added to PATH variable.  Aborting."; exit 1; }
command -v python >/dev/null || {  echo >&2 "CCsolve requires python but it's either not installed or not added to PATH variable.  Aborting."; exit 1; }
command -v perl >/dev/null || {  echo >&2 "CCsolve requires perl but it's either not installed or not added to PATH variable.  Aborting."; exit 1; }
command -v mammoth >/dev/null || {  echo >&2 "CCsolve requires mammoth but it's either not installed or not added to PATH variable.  Aborting."; exit 1; }
command -v clustalw >/dev/null || {  echo >&2 "CCsolve requires clustalw but it's either not installed or not added to PATH variable.  Aborting."; exit 1; }

scripts=`egrep '^scripts' cc_solv.conf | awk '{print $3}'`

nohup $scripts/run_phaser.sh &
wait $!
nohup $scripts/run_phenix.refine.sh &
wait $!
nohup $scripts/run_autobuild.sh &
wait $!
nohup $scripts/run_autobuild_inPlace.sh &
