#!/usr/bin/perl

##  This script is distributed as part of the
##	CCsolve program.
##
##	For review only.
##
##	It may not be distributed until publication.
##
##


#
#  extract one chain from a given pdb file and send it to STDOUT

if( @ARGV < 2 ) {
    die "Usage: $0 <pdb_file> <chain1> <chain2> ...(\_ for no_chain_id)\n";
}

$file = shift(@ARGV);
chomp $file;


for ($i=0; $i<=$#ARGV; $i++) {
    $chain = $ARGV[$i];
    if ($chain eq "_") {
	$chain = " ";
    }

    open (INFILE, $file)|| die "Couldn't open $file\n";

    while (<INFILE>) {
	if (/^ATOM/) {
	    $altLoc = substr ($_,16,1);
	    next if ($altLoc ne " " && $altLoc ne "A");
	    $pdbchain = substr ($_, 21, 1);
	    print STDOUT $_ if ($pdbchain eq $chain);
	    }
    }
    close (INFILE);
}
exit 0;
