#!/usr/bin/python

##  This script is distributed as part of the
##	CCsolve program.
##
##	For review only.
##
##	It may not be distributed until publication.
##
##



#!/usr/bin/python

###################################################
#
# This script uses the clustalw sequence alignment,
# done before the last rebuilding step, if
# phenix autobuild -in_place cannot align the
# sequence from the fasta file onto the helices
# with wrong sequences
#
# Author: Sebastian Ramisch

import re
import math
from sys import exit
from sys import argv,stdout
from os.path import exists


if argv.count('-best_helix'):
	pos = argv.index('-best_helix')
	best_helix = argv[pos+1]
else:
	print "make_correct_sequence.py: Parameter missing"
	print "Required input parameters:"
	print "-best_helix <pdb name, string>"
	print ""
	exit(1)

corr_seq = []
wrong_seq = []

file = open('helices.aln', 'r')
lines = file.readlines()

# full peptide sequence according to fasta file:
name = lines[3].split()[0]
pattern = re.compile(name)
full_seq = ''
for line in lines:
  if re.match(pattern, line):
		full_seq = full_seq + line.split()[1]

# find sequence of the best aligned helix
pattern = re.compile(best_helix)
wrong_seq = ''
for line in lines:
	if re.match(pattern, line):
		wrong_seq = wrong_seq + line.split()[1]

for i in range(0, len(wrong_seq)):
	if wrong_seq[i] != '-':
		corr_seq.append(full_seq[i])

str=''.join(corr_seq)

out_file = open('monomer.seq', 'w')
out_file.write(str)
out_file.close()

print 'monomer.seq file created \n Sequence: ' + str

