#!/bin/bash

seq=`sed -n '2p' $1.fasta`
seq_len=`expr length $seq`

rosetta_database=`egrep '^rosetta_database' ../cc_solv.conf | awk '{print $3}'`


if command -v cc_frag_picker.linuxclangrelease ; then
	ROS_EX=cc_frag_picker.linuxclangrelease
elif command -v cc_frag_picker.linuxgccrelease; then
	ROS_EX=cc_frag_picker.linuxgccrelease
elif command -v cc_frag_picker.static.linuxclangrelease; then
	ROS_EX=cc_frag_picker.static.linuxclangrelease
elif command -v cc_frag_picker.static.linuxgccrelease; then
	ROS_EX=cc_frag_picker.static.linuxgccrelease
elif command -v cc_frag_picker.linuxiccgrelease; then
	ROS_EX=cc_frag_picker.linuxiccgrelease
elif command -v cc_frag_picker.static.linuxiccgrelease; then
	ROS_EX=cc_frag_picker.static.linuxiccgrelease
fi
if [ "$ROS_EX" = "" ]; then
	echo "No Rosetta executable found. Exiting .."
else
	echo "Found $ROS_EX"
	echo ""
	echo "Running the dimer-fragment picker ..."
fi

cd struct_database
$ROS_EX \
	-database $rosetta_database \
	-in::file::l list \
	-ignore_unrecognized_res \
	-cc_frag_app::frag_length 9 \
	-cc_frag_app::sequence_length $seq_len \
	-cc_frag_app::frag_name $1\_9mer.dat \
	-mute all
wait
$ROS_EX \
	-database $rosetta_database \
	-in::file::l list \
	-ignore_unrecognized_res \
	-cc_frag_app::frag_length 3 \
	-cc_frag_app::sequence_length $seq_len \
	-cc_frag_app::frag_name $1\_3mer.dat \
	-mute all
wait
echo ""
echo ""
echo "Rosetta fragment picking finished"
echo "Run duplicate_frags.sh "
echo "(This way you obtain identical fragments for both helices, which is important for accurate structure prediction.)"
mv *dat ../inputs
cd ../inputs
duplicate_frags.sh $1\_3mer.dat $1\_9mer.dat
wait
rm $1\_3mer.dat $1\_9mer.dat
if [ -s  $1\_3mer.dat_duplicated ] && [ -s $1\_9mer.dat_duplicated ]; then
	echo "Duplicated fragment files successfully created and copied to ./inputs"
fi
cd ../
exit 0
