#!/usr/bin/python
## make mammoth structure alignments


import string
from glob import glob
from sys import argv,stderr
from os import popen,system
from os.path import exists
from operator import add

#############################

if len(argv) <=2:
    print 'USAGE: %s pdb1 pdb2 > <superimposition-pdb>'%argv[0]
    print '\n Superimpose pdb2 onto pdb1 using maxsub'


model_count = 0
atom_count = 0

args = argv[1:]
pdb1 = args[0]
pdb2 = args[1]

command = 'mammoth -p %s -e %s -r y 2> /dev/null | grep PSI.end'\
             %(pdb1,pdb2)

lines = popen(command).readlines()

if not lines:
	print "Superimposition did not work. Something wrong with the pdb files?"

l = string.split(lines[0])
stderr.write('%s -vs- %s: %s over %s residues\n'%(pdb1,pdb2,l[7],l[3]))


file = 'maxsub_sup.pdb'
matrix = map(lambda x:map(float,string.split(x)[1:]),
            popen('grep -A3 "Transformation Matrix" %s'%file).readlines()[1:4])


P_translation = map(float,
                        string.split(popen('grep -A1 "Translation vector (Pred" %s'\
                                           %file).readlines()[1])[1:])

E_translation = map(float,
             string.split(popen('grep -A1 "Translation vector (Exp" %s'\
                                %file).readlines()[1])[1:])


def E_transform(v,matrix,tP,tE):
        ans = [0.0]*3
        for i in range(3):
            for j in range(3):
                ans[i] = ans[i] + matrix[i][j]*(v[j]-tE[j])
            ans[i] = ans[i] + tP[i]

        return ans

data = open(pdb1,'r')
line = data.readline()
while line:
	if line[:4] in ['ATOM','HETA']:
		atom_count = atom_count + 1
		print '%s  %5d%s'%(line[:4],atom_count,line[11:-1])
	elif line[:6] == 'ENDMDL':break
	line = data.readline()
data.close()
print 'ENDMDL'

data = open(pdb2,'r')
line = data.readline()
while line:
    if line[:4] in ['ATOM','HETA']:
            atom_count = atom_count + 1
            pos = E_transform(map(float,[line[30:38],line[38:46],line[46:54]]),
                              matrix,
                              P_translation,
                              E_translation)

            print '%s  %s%8.3f%8.3f%8.3f%s'\
                  %(line[:4],line[6:30],pos[0],pos[1],pos[2],line[54:-1])

    elif line[:6] == 'ENDMDL':break
    line = data.readline()
data.close()

print 'ENDMDL'

system('rm maxsub_sup.pdb maxsub_sup2.pdb rasmol.tcl')
